local ADDON, Addon = ...;

EnabledItems = EnabledItems or {}
EnabledParts = EnabledParts or {}

--[[ core functions ]]--

function Addon:SellItem(slot)
	UseContainerItem(Addon:GetBagSlot(slot));
end

function Addon:AllowSellItem(slot)
	local canSell = true;
	canSell = not Addon:GetItemIsInSet(slot);
	canSell = canSell and Addon:CanSellItem(slot);
	canSell = canSell and not Addon:ItemAccountbound(slot);
	canSell = canSell and Addon:EvaluateEquip(slot);
	canSell = canSell and not Addon:GetItemIsInSet(slot);
	return canSell;
end

function Addon:EvaluateEquip(slot)
	if not Addon:IsArmor(slot) and not Addon:IsWeapon(slot) then return true end

	local canWear = false;
	if Addon:IsArmor(slot) then 
		canWear = Addon:PlayerCanWearArmor(slot);
	elseif Addon:IsWeapon(slot) then
		canWear = Addon:PlayerCanWearWeapon(slot);
	end
	
	local sb = Addon:ItemSoulbound(slot);

	if sb and not canWear then return true end
	if not sb then return true end
	return true
	--if sb and not Addon:BetterThanActualEquip(slot) then return true end
end

function Addon:StyleButton(btn, ico, size)
	if size == nil then size = 36 end
	
	local multiplicator = 64 / 39
	local shown = btn:IsShown()

	local nt = btn:CreateTexture()
	nt:SetTexture([[Interface\Buttons\UI-Quickslot2]])
	nt:SetSize(size * multiplicator, size * multiplicator)
	nt:SetPoint('CENTER', 0, 0)
	btn:SetNormalTexture(nt)

	local pt = btn:CreateTexture()
	pt:SetTexture([[Interface\Buttons\UI-Quickslot-Depress]])
	pt:SetSize(size, size)
	pt:SetAllPoints(btn)
	btn:SetPushedTexture(pt)

	local ht = btn:CreateTexture()
	ht:SetTexture([[Interface\Buttons\ButtonHilight-Square]])
	ht:SetSize(size, size)
	ht:SetAllPoints(btn)
	btn:SetHighlightTexture(ht)
	
	if ico == nil then return end
	
	local icon = btn:CreateTexture()
	icon:SetTexture(ico or [[Interface\PaperDoll\UI-Backpack-EmptySlot]])
	icon:SetSize(size, size)
	icon:SetAllPoints(btn)
	
	if shown then
		btn:Show()
	else
		btn:Hide()
	end
end