local ADDON, Addon  = ...;

local statTable  = {
	[1] =  { [1] = "ITEM_MOD_STRENGTH_SHORT",  [2] = "ITEM_MOD_STRENGTH_SHORT",  [3] = "ITEM_MOD_STRENGTH_SHORT" }, -- Warrior
	[2] =  { [1] = "ITEM_MOD_INTELLECT_SHORT", [2] = "ITEM_MOD_STRENGTH_SHORT",  [3] = "ITEM_MOD_STRENGTH_SHORT" }, -- Paladin
	[3] =  { [1] = "ITEM_MOD_AGILITY_SHORT",   [2] = "ITEM_MOD_AGILITY_SHORT",   [3] = "ITEM_MOD_AGILITY_SHORT" }, -- Hunter
	[4] =  { [1] = "ITEM_MOD_AGILITY_SHORT",   [2] = "ITEM_MOD_AGILITY_SHORT",   [3] = "ITEM_MOD_AGILITY_SHORT" }, -- Rouge
	[5] =  { [1] = "ITEM_MOD_INTELLECT_SHORT", [2] = "ITEM_MOD_INTELLECT_SHORT", [3] = "ITEM_MOD_INTELLECT_SHORT" }, -- Priest
	[6] =  { [1] = "ITEM_MOD_STRENGTH_SHORT",  [2] = "ITEM_MOD_STRENGTH_SHORT",  [3] = "ITEM_MOD_STRENGTH_SHORT" }, -- Deathknight
	[7] =  { [1] = "ITEM_MOD_INTELLECT_SHORT", [2] = "ITEM_MOD_AGILITY_SHORT",   [3] = "ITEM_MOD_INTELLECT_SHORT" }, -- Shaman
	[8] =  { [1] = "ITEM_MOD_INTELLECT_SHORT", [2] = "ITEM_MOD_INTELLECT_SHORT", [3] = "ITEM_MOD_INTELLECT_SHORT" }, -- Mage
	[9] =  { [1] = "ITEM_MOD_INTELLECT_SHORT", [2] = "ITEM_MOD_INTELLECT_SHORT", [3] = "ITEM_MOD_INTELLECT_SHORT" }, -- Warlock
	[10] = { [1] = "ITEM_MOD_AGILITY_SHORT",   [2] = "ITEM_MOD_INTELLECT_SHORT", [3] = "ITEM_MOD_AGILITY_SHORT" }, -- Monk
	[11] = { [1] = "ITEM_MOD_INTELLECT_SHORT", [2] = "ITEM_MOD_AGILITY_SHORT",   [3] = "ITEM_MOD_AGILITY_SHORT", [4] = "ITEM_MOD_INTELLECT_SHORT" } -- Druid
}

local prefArmor = {
	[1] = 5,
	[2] = 5,
	[3] = 4,
	[4] = 3,
	[5] = 2,
	[6] = 5,
	[7] = 4,
	[8] = 2,
	[9] = 2,
	[10] = 3,
	[11] = 3
}

local weaponIndex = {
	[1] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	[2] = { 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 1 },
	[3] = { 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1 },
	[4] = { 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 1 },
	[5] = { 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1 },
	[6] = { 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 0, 0, 1 },
	[7] = { 1, 1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1 },
	[8] = { 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 0, 0, 0, 1 },
	[9] = { 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 0, 0, 0, 1 },
	[10] = { 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1 },
	[11] = { 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1 }
}

local invTypeToSlotMapping = {
	{ { INVSLOT_HEAD }, INVTYPE_HEAD },
	{ { INVSLOT_NECK }, INVTYPE_NECK },
	{ { INVSLOT_SHOULDER }, INVTYPE_SHOULDER },
	{ { INVSLOT_BODY }, INVTYPE_BODY },
	{ { INVSLOT_CHEST }, INVTYPE_CHEST },
	{ { INVSLOT_WAIST }, INVTYPE_WAIST },
	{ { INVSLOT_LEGS }, INVTYPE_LEGS },
	{ { INVSLOT_FEET }, INVTYPE_FEET },
	{ { INVSLOT_WRIST }, INVTYPE_WRIST },
	{ { INVSLOT_HAND }, INVTYPE_HAND },
	{ { INVSLOT_FINGER1, INVSLOT_FINGER2 }, INVTYPE_FINGER },
	{ { INVSLOT_TRINKET1, INVSLOT_TRINKET2 }, INVTYPE_TRINKET },
	{ { INVSLOT_BACK }, INVTYPE_CLOAK },
	{ { INVSLOT_RANGED }, INVTYPE_RANGED },
	{ { INVSLOT_MAINHAND, INVSLOT_OFFHAND }, INVTYPE_WEAPON },
	{ { INVSLOT_MAINHAND }, INVTYPE_2HWEAPON },
	{ { INVSLOT_OFFHAND }, INVTYPE_HOLDABLE, INVTYPE_SHIELD },
	{ { INVSLOT_TABARD }, INVTYPE_TABARD }
};

function Addon:GetID(slot)
	return slot[Addon.T_ID];
end

function Addon:GetName(slot)
	return slot[Addon.T_NAME];
end

function Addon:GetItemTexture(slot)
	return slot[Addon.T_TEXTURE];
end

function Addon:GetItemQuality(slot)
	return slot[Addon.T_QUALITY];
end

function Addon:GetItemCount(slot)
	return slot[Addon.T_COUNT];
end

function Addon:GetItemLink(slot)
	return slot[Addon.T_LINK];
end

function Addon:GetItemIsInSet(slot)
	return slot[Addon.T_INSET];
end

function Addon:GetItemType(slot)
	return slot[Addon.T_TYPE];
end

function Addon:GetItemTypeIndex(slot)
	return slot[Addon.T_TYPEINDEX]
end

function Addon:GetItemSubType(slot)
	return slot[Addon.T_SUBTYPE];
end

function Addon:GetItemSubTypeIndex(slot)
	return slot[Addon.T_SUBTYPEINDEX]
end

function Addon:GetItemEquipLoc(slot)
	return slot[Addon.T_EQUIPLOC];
end

function Addon:GetSellPrice(slot)
	return slot[Addon.T_SELLPRICE];
end

function Addon:ItemSoulbound(slot)
   return slot[Addon.T_SOULBOUND];
end

function Addon:ItemAccountbound(slot)
   return slot[Addon.T_ACCOUNTBOUND];
end

function Addon:GetItemStats(slot)
	return slot[Addon.T_STATS];
end

function Addon:GetBagSlot(slot)
	return slot[Addon.T_BAG], slot[Addon.T_SLOT];
end

function Addon:GetItemLevel(slot)
	return slot[Addon.T_GS];
end

function Addon:GetPlayerClassID()
	return select(3, UnitClass("player"));
end

function Addon:CanSellItem(slot)
	local amount = Addon:GetSellPrice(slot);
	return amount ~= 0;
end

function Addon:HasPreferredStats(slot)
	if not Addon:IsArmor(slot) and not Addon:IsWeapon(slot) then
		error("Given item is no armor or weapon!");
	end
	
	local unitClass = Addon:GetPlayerClassID();
	local spec = GetSpecialization();
	local primStat = statTable[unitClass][spec];
	local itemStats = Addon:GetItemStats(slot);
	local primStat = itemStats[primStat];
	
	return primStat ~= nil
end

function Addon:GetPrefPlayerArmor()
	local unitClass = Addon:GetPlayerClassID();
	local armor = prefArmor[unitClass];
	
	local function act()
		if UnitLevel("player") < 40 then
			armor = armor - 1;
		end
	end
	
	local mapping = { { act, 1, 2, 3, 7 } };
	map(unitClass) : to(mapping);
	return armor;
end

function Addon:IsCottonArmor(slot)
	local equipLoc  = Addon:GetItemEquipLoc(slot);
	local armor = Addon:GetPrefPlayerArmor();
	
	if not equipLoc then return false end
	
	for _, t, active in idoublepair(GetAuctionInvTypes(2, armor)) do
		if equipLoc == t and active then return true end
	end
	
	return false
end

function Addon:IsArmor(slot)
	local ty, tyIdx = Addon:GetItemTypes(slot);
	return tyIdx == 2
end

function Addon:IsWeapon(slot)
	local ty, tyIdx = Addon:GetItemTypes(slot);
	return tyIdx == 1
end

function Addon:GetItemTypes(slot)
	local ty = Addon:GetItemType(slot);
	local tyIndex = Addon:GetItemTypeIndex(slot);
	local subType = Addon:GetItemSubType(slot);
	local subTypeIndex = Addon:GetItemSubTypeIndex(slot);
   
    return ty, tyIndex, subType, subTypeIndex;
end

function Addon:GetItemInvTypeID(slot)
	local subClassType = Addon:GetItemSubType(slot);
	local equipSlot = Addon:GetItemEquipLoc(slot);
	
	for i, t, active in idoublepair(GetAuctionInvTypes(2, subClassType)) do
		if equipSlot == t then
			return i;
		end
	end
	
	return nil;
end

function Addon:PlayerCanWearWeapon(slot)
	local unitClass = Addon:GetPlayerClassID();
	
	if not Addon:IsWeapon(slot) then return true end

	local subClassIndex = select(4, Addon:GetItemTypes(slot));
	
	return weaponIndex[unitClass][i] == 1;
end

function Addon:PlayerCanWearArmor(slot)
	local ty, tyIndex, subType, subTypeIndex = Addon:GetItemTypes(slot);
	
	if not Addon:IsArmor(slot) then return false end
	
	if subTypeIndex == 6 then return true end
	if subTypeIndex > 7 then return true end
	if subTypeIndex > Addon:GetPrefPlayerArmor() then return false end
	return true
end

function Addon:SameItemType(slot1, slot2)
	local equipSlotType1 = Addon:GetItemEquipLoc(link1);
	local equipSlotType2 = Addon:GetItemEquipLoc(link2);

	return equipSlotType1 == equipSlotType2;
end

function Addon:BetterThanActualEquip(slot)
	local better = true
	if not Addon:IsArmor(slot) and not Addon:IsWeapon(slot) then
		error("Given item is no armor or weapon!");
	end
	
	local invType = Addon:GetItemEquipLoc(slot);
	
	if not invType then 
		return false
	end
	
	local slots = { MapInvTypeToInvSlots(invType) };
	for _, s in ipairs(slots) do
		local itemLink = GetInventoryItemLink("player", s)
		if itemLink then
			local itemInSlot = Addon:LinkToSlot(itemLink);
			
			if not (Addon:HasPreferredStats(itemInSlot) and not Addon:HasPreferredStats(slot)
				or Addon:HasPreferredStats(itemInSlot) and Addon:HasPreferredStats(slot) and Addon:GetItemLevel(slot) > Addon:GetItemLevel(itemInSlot))
				then
				better = false
			end
		else
			better = true
		end
	end
	return better
end

function Addon:IsCritical(slot)
	local critical = false
	local minItemLevel = Addon:GetItemLevel(slot);
	local invType = Addon:GetItemEquipLoc(slot);
	local sb = Addon:ItemSoulbound(slot);
	local prefArmor = Addon:GetPrefPlayerArmor();
	local ty, tyIdx, subType, subTypeIndex = Addon:GetItemTypes(slot);
	
	if (Addon:IsWeapon(slot) or Addon:IsArmor(slot)) then
		if not sb and Addon:GetItemQuality(slot) > 1 then return true end
	
		if Addon:IsCottonArmor(slot) then
			if subTypeIndex ~= prefArmor then return false end
		end
		if not Addon:HasPreferredStats(slot) then return false end
		
		local canWear = false;
		if Addon:IsArmor(slot) then 
			canWear = Addon:PlayerCanWearArmor(slot);
		elseif Addon:IsWeapon(slot) then
			canWear = Addon:PlayerCanWearWeapon(slot);
		end
		
		if not canWear then return false end
		
		if invType then
			for _, s in ipairs({ MapInvTypeToInvSlots(invType) }) do
				local itemLink = GetInventoryItemLink("player", s)
				if itemLink then
					local itemInSlot = Addon:LinkToSlot(itemLink);
					local level = Addon:GetItemLevel(itemInSlot)
					
					if level == nil then
						critical = true
					end
					
					if itemInSlot then
						if Addon:GetItemLevel(itemInSlot) <= minItemLevel then
							critical = true
						end
						
						if Addon:GetItemQuality(itemInSlot) == 7 then
							critical = false
						end
					else
						critical = true
					end
				else
					critical = true
				end
			end
		end
	end
	
	return (Addon:EvaluateEquip(slot) and critical and Addon:GetItemQuality(slot) > 1)
		   or Addon:GetItemEquipLoc(slot) == "INVTYPE_TABARD";
end

--[[ Utility Functions ]]--

function MapInvTypeToInvSlots(invType)
	return choose(_G[invType]) : from(invTypeToSlotMapping);
end

function idoublepair(t)
   local function dbit(t, i)
      local v = t[i + 1];
      local w = t[i + 2];
      
      i = i + 2;
      
      if w ~= nil then
         return i, v, w;
      else
         return nil;
      end
   end
   return dbit, t, 0;
end

function sortBase(t, cond)
	local ts = {};
	local it = nil;
	
	if t[1] then
		it = ipairs;
	else
		it = pairs;
	end
	
	for k, v in it(t) do
		local inserted = nil;
		local size = table.getn(ts);
		
		for idx, v2 in ipairs(ts) do
			local c = cond(v, v2);
			
			if c == true then
				table.insert(ts, idx, v);
				inserted = true;
				break;
			elseif c == 0 then
				for q = idx, size do
					if q == size or cond(v, ts[q + 1]) ~= 0 then
						table.insert(ts, q + 1, v);
						inserted = true;
						break;
					end
				end
				break;
			end
	    end
		
		if not inserted then
			table.insert(ts, size + 1, v);
		end
	end
	
	return ts;
end

function levelSort(t)
	return sortBase(t, function(s1, s2)
		local v1 = Addon:GetItemLevel(s1);
		local v2 = Addon:GetItemLevel(s2);
		
		if v1 == v2 then
			return 0;
		elseif v1 and v2 then
			return v1 < v2;
		end
	end);
end

function levelSortDesc(t)
	return sortBase(t, function(s1, s2)
		local v1 = Addon:GetItemLevel(s1);
		local v2 = Addon:GetItemLevel(s2);
		
		if v1 == v2 then
			return 0;
		elseif v1 and v2 then
			return v1 > v2;
		end
	end);
end

function itemSubTypeSort(t)
	return sortBase(t, function(s1, s2)
		local v1 = Addon:GetItemSubTypeIndex(s1);
		local v2 = Addon:GetItemSubTypeIndex(s2);
		
		if v1 == v2 then
			return 0;
		elseif v1 and v2 then
			return v1 < v2;
		end
	end);
end

function itemSubTypeSortDesc(t)
	return sortBase(t, function(s1, s2)
		local v1 = Addon:GetItemSubTypeIndex(s1);
		local v2 = Addon:GetItemSubTypeIndex(s2);
		
		if v1 == v2 then
			return 0;
		elseif v1 and v2 then
			return v1 > v2;
		end
	end);
end

function itemInvTypeSort(t)
	return sortBase(t, function(s1, s2)
		local v1 = Addon:GetItemEquipLoc(s1);
		local v2 = Addon:GetItemEquipLoc(s2);
		
		local sortedTable = { v1, v2 };
		table.sort(sortedTable);
		
		if v1 == v2 then
			return 0;
		elseif sortedTable[1] == v1 then
			return true;
		end
	end);
end

function itemNameSort(t)
	return sortBase(t, function(s1, s2)
		local v1 = Addon:GetName(s1);
		local v2 = Addon:GetName(s2);
		local m = string.len(v1);
		local n = string.len(v2);
		
		local sortedTable = { v1, v2 };
		table.sort(sortedTable);
		
		if v1 == v2 then
			return 0;
		elseif sortedTable[1] == v1 then 
			return true
		end
	end);
end

function sortedArmor(t)
	local ts = itemInvTypeSort(levelSortDesc(itemSubTypeSortDesc(itemNameSort(t))));

   local function s(ts, i)
	  i = i + 1;
      local v = ts[i];
	  
      if v ~= nil then
         return i, v;
      else
         return nil;
      end
   end
   return s, ts, 0;
end

function sortedOther(t)
	local ts = itemSubTypeSortDesc(levelSortDesc(itemNameSort(t)));

   local function s(ts, i)
	  i = i + 1;
      local v = ts[i];
	  
      if v ~= nil then
         return i, v;
      else
         return nil;
      end
   end
   return s, ts, 0;
end

function choose(arg)
   local f = {
      from = function(self, tbl)
         for _, case in ipairs(tbl) do
            local funCase = case[1];
            if type(funCase) == "table" then
               case[1] = function()
                  return unpack(funCase);
               end
            end
         end
         return map(arg) : to(tbl);
      end
   };
   return f;
end

function map(arg)
   local f  = {
      to  = function(self, tbl)
         local default = nil;
         for _, case in ipairs(tbl) do
            if type(case) == "function" then
               default = case;
            else
               for idx, input in ipairs { select(2, unpack(case)) } do
                  local func = case[1];
                  if type(func) == "function" and input == arg then
                     return case[1]();
                  end
               end
            end
         end
         if default then default() end
      end
   };
   return f;
end